const db = require('../db/models');
const ValidationError = require('./notifications/errors/validation');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

/**
 * @param {string} permission
 * @param {object} currentUser
 */
async function checkPermissions(permission, currentUser) {
  if (!currentUser) {
    throw new ValidationError('auth.unauthorized');
  }

  const userPermission = currentUser.custom_permissions.find(
    (cp) => cp.name === permission,
  );

  if (userPermission) {
    return true;
  }

  try {
    if (!currentUser.app_role) {
      throw new ValidationError('auth.forbidden');
    }

    const permissions = await currentUser.app_role.getPermissions();

    return !!permissions.find((p) => p.name === permission);
  } catch (e) {
    throw e;
  }
}

module.exports = class SearchService {
  static async search(searchQuery, currentUser) {
    try {
      if (!searchQuery) {
        throw new ValidationError('iam.errors.searchQueryRequired');
      }
      const tableColumns = {
        users: ['firstName', 'lastName', 'phoneNumber', 'email', 'clientId'],

        organizations: ['name'],

        brands: [
          'name',

          'client_fixed_text',

          'yes_fixed_text',

          'default_client_contact',

          'temp',

          'xero_id',
        ],

        brand_rate_cards: [
          'name',

          'rate_card_type',

          'status',

          'currency',

          'discipline',

          'output_channel',

          'staff_skills',

          'rate_card_owner',

          'rate_card_id',

          'markets',

          'languages',

          'version_number',

          'commercial_owner',

          'assumptions',

          'no_fixed_text',

          'yes_fixed_text',
        ],

        client_orders: ['status', 'order_name', 'order_number'],

        countries: ['name', 'currency', 'default_prefill'],

        clients: [
          'thyme_id',

          'name',

          'office',

          'address',

          'city',

          'post_code',

          'country_txt',

          'phone_number',

          'website',

          'currency',

          'curious_customer_id',

          'agency',

          'client_id_link',

          'public_url',

          'xero_id',
        ],

        default_activities_products: [
          'name',

          'rate_type',

          'standard_service',

          'service_text',

          'service_id',

          'service_code',

          'unit_type',

          'currency',
        ],

        departments: ['name', 'timing_id'],

        markets: ['market'],
      };
      const columnsInt = {
        brands: ['default_costs', 'production_fee', 'insurance_fee'],

        brand_rate_cards: ['service_count'],

        clients: ['early_payment_discount', 'production_fee', 'insurance_fee'],

        default_activities_products: [
          'rate',

          'cost',

          'qty',

          'rate_gbp',

          'rate_eur',

          'rate_usd',
        ],
      };

      let allFoundRecords = [];

      for (const tableName in tableColumns) {
        if (tableColumns.hasOwnProperty(tableName)) {
          const attributesToSearch = tableColumns[tableName];
          const attributesIntToSearch = columnsInt[tableName] || [];
          const whereCondition = {
            [Op.or]: [
              ...attributesToSearch.map((attribute) => ({
                [attribute]: {
                  [Op.iLike]: `%${searchQuery}%`,
                },
              })),
              ...attributesIntToSearch.map((attribute) =>
                Sequelize.where(
                  Sequelize.cast(
                    Sequelize.col(`${tableName}.${attribute}`),
                    'varchar',
                  ),
                  { [Op.iLike]: `%${searchQuery}%` },
                ),
              ),
            ],
          };

          const hasPermission = await checkPermissions(
            `READ_${tableName.toUpperCase()}`,
            currentUser,
          );
          if (!hasPermission) {
            continue;
          }

          const foundRecords = await db[tableName].findAll({
            where: whereCondition,
            attributes: [
              ...tableColumns[tableName],
              'id',
              ...attributesIntToSearch,
            ],
          });

          const modifiedRecords = foundRecords.map((record) => {
            const matchAttribute = [];

            for (const attribute of attributesToSearch) {
              if (
                record[attribute]
                  ?.toLowerCase()
                  ?.includes(searchQuery.toLowerCase())
              ) {
                matchAttribute.push(attribute);
              }
            }

            for (const attribute of attributesIntToSearch) {
              const castedValue = String(record[attribute]);
              if (
                castedValue &&
                castedValue.toLowerCase().includes(searchQuery.toLowerCase())
              ) {
                matchAttribute.push(attribute);
              }
            }

            return {
              ...record.get(),
              matchAttribute,
              tableName,
            };
          });

          allFoundRecords = allFoundRecords.concat(modifiedRecords);
        }
      }

      return allFoundRecords;
    } catch (error) {
      throw error;
    }
  }
};
